#!/bin/bash

scaling="2 4 6 8"
#scaling="2 4 6 8 10"
#scaling="2 4"
configs="pess-repl-async.xml pess-repl-sync.xml pess-repl-async-br.xml"
products="jbosscache-2.0.0 jbosscache-2.1.0"

mkdir output

for product in $products
do
	for config in $configs
	do
		for size in $scaling
		do
			./cluster.sh start $product $config $size

			outputFileName=data_${product}_${config}_${size}.csv
			while [ ! -e $outputFileName ]
			do
				echo "Waiting for report [ $outputFileName ]"
				sleep 5
			done
			sleep 60
			mv $outputFileName output/
		done
	done
done


echo Generating charts ... 

./generateChart -reportDir output
