package org.cachebench.cachewrappers;

import org.cachebench.CacheWrapper;

import java.util.Map;

import com.tangosol.net.NamedCache;
import com.tangosol.net.CacheFactory;

/**
 *
 * Pass in a -Dtangosol.coherence.localhost=IP_ADDRESS
 *
 * @author <a href="mailto:manik@jboss.org">Manik Surtani</a>
 * @since 2.0.0
 */
public class CoherenceWrapper implements CacheWrapper
{
   NamedCache cache;

   public void init(Map parameters) throws Exception
   {
      cache = CacheFactory.getReplicatedCache();
//      cache = CacheFactory.getCache("VirtualCache");
   }

   public void setUp() throws Exception
   {
   }

   public void tearDown() throws Exception
   {
      cache.release();
   }

   public void put(Object key, Object value) throws Exception
   {
      cache.put(key, value);
   }

   public Object get(Object key) throws Exception
   {
      return cache.get(key);
   }

   public void empty() throws Exception
   {
      cache.clear();
   }

   public int getNumMembers()
   {
      return cache.getCacheService().getCluster().getMemberSet().size();
   }

   public String getInfo()
   {
      return cache.keySet().toString();
   }

   public Object getReplicatedData(String key) throws Exception
   {
      return get(key);
   }
}
