package org.cachebench.cachewrappers;

import org.cachebench.CacheWrapper;

import java.util.Map;
import java.util.HashMap;

/**
 * Cache wrapper for Terracotta 2.3.0
 *
 * Using the terracotta-cache package on http://www.terracotta.org/confluence/display/labs/Terracotta+Cache
 *
 * @author <a href="manik@jboss.org">Manik Surtani</a>
 */
public class TerracottaWrapper implements CacheWrapper
{
   // Since terracotta 
   private final Map cache = new HashMap();

   public void init(Map parameters) throws Exception
   {
   }

   public Object getReplicatedData(String key) throws Exception
   {
      return get(key);
   }

   public void setUp() throws Exception
   {
   }

   public void tearDown() throws Exception
   {
      synchronized(cache)
      {
         cache.clear();
      }
   }

   public void put(Object key, Object value) throws Exception
   {
      synchronized(cache)
      {
         cache.put(key, value);
      }
   }

   public Object get(Object key) throws Exception
   {
      synchronized(cache)
      {
         return cache.get(key);
      }
   }

   public void empty() throws Exception
   {
      synchronized(cache)
      {
         cache.clear();
      }
   }

   public int getNumMembers()
   {
      return -1;
   }

   public String getInfo()
   {
      synchronized(cache)
      {
         return "There are " + cache.size() + " objects in cache";
      }
   }

}
