package org.cachebench;

import java.io.Serializable;


/**
 * @author Manik Surtani (manik@surtani.org)
 * @version $Id: SerializableCacheWrapper.java,v 1.4 2007/04/18 19:09:29 msurtani Exp $
 */
public interface SerializableCacheWrapper extends CacheWrapper
{
   /**
    * Similar to get, only uses serializable objects
    *
    * @param key The key of the value in cache.
    * @return The value in cache.
    */
   Object getSerializable(Serializable key) throws Exception;

   /**
    * Similar to put, only uses serializable objects
    *
    * @param key   The serializable key in which the value will be saved.
    * @param value The serializable value be saved.
    */
   void putSerializable(Serializable key, Serializable value) throws Exception;
}
